<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json" 
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Message"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="java.util.List"
	import="org.json.simple.JSONObject"
%>
<%
response.setHeader("Cache-Control", "no-cache, max-age=0");
final SessionControl sc = Base.getSessionControl(pageContext, false);
final String ID = sc == null ? "" : sc.getId();
final String cmd = request.getParameter("cmd");
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
DbControl dc = null;
try
{
	if ("GetFootnoteMessages".equals(cmd))
	{
		String broadcastTitle = (String)application.getAttribute("broadcast.title");
		json.put("broadcast", broadcastTitle);
		
		if (sc != null && sc.isLoggedIn())
		{
			dc = sc.newDbControl();
			long numNewMessages = Message.countUnreadMessages(dc, null, false);

			json.put("newMessages", numNewMessages);
			
			if (numNewMessages == 1)
			{
				User user = User.getById(dc, sc.getLoggedInUserId());
				ItemQuery<Message> query = Message.getQuery(user);
				query.restrict(
					Restrictions.eq(
						Hql.property("read"),
						Expressions.parameter("read")
					)
				);
				query.setParameter("read", false, Type.BOOLEAN);
				List<Message> messages = query.list(dc);
				Message message = messages.get(0);
				
				JSONObject jsonMessage = new JSONObject();
				jsonMessage.put("id", message.getId());
				jsonMessage.put("name", message.getName());
				jsonMessage.put("from", message.getFrom());
				json.put("message", jsonMessage);
			}
		}
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>