<%-- $Id: edit_file.jsp 6607 2014-11-19 14:52:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	File file = null;
	Directory directory = null;
	boolean readCurrentSubtype = true;
	int currentSubtypeId = 0;
	boolean readCurrentFileServer = true;
	FileServer currentFileServer = null;
	List<FileServer> recentFileServers = (List<FileServer>)cc.getRecent(dc, Item.FILESERVER);
	boolean isURL = true;

	if (itemId == 0)
	{
		title = "New URL";
		currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		if (currentSubtypeId == 0) 
		{
			int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
			currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
		}
		if (cc.getPropertyFilter("fileServer.name") != null)
		{
			currentFileServer = Base.getFirstMatching(dc, FileServer.getQuery(), "name", cc.getPropertyFilter("fileServer.name"));
		}
		directory = Directory.getById(dc, Values.getInt(request.getParameter("directory_id"), 
			SystemItems.getId(Directory.ROOT)));
		cc.removeObject("item");
	}
	else
	{
		file = File.getById(dc, itemId);
		file.checkPermission(Permission.WRITE);
		isURL = file.getLocation() == Location.EXTERNAL;
		directory = file.getDirectory();
		cc.setObject("item", file);
		title = (isURL ? "Edit URL -- " : "Edit file -- ") + HTML.encodeTags(file.getName());
		try
		{
			ItemSubtype subtype = file.getItemSubtype();
			if (subtype != null) currentSubtypeId = subtype.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentFileServer = file.getFileServer();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileServer = false;
		}
	}
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), file);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~files.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="file">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="directory_id" value="<%=directory.getId()%>">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=file != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="<%=isURL ? "URL" : "File" %>" helpid="file.edit">
			<table class="fullform input100">
			<tr>
				<th>Path</th>
				<td colspan="2"><%=HTML.encodeTags(directory.getPath().toString())%></td>
			</tr>
			<%
			if (isURL)
			{
				%>
				<tr class="double">
					<th>URL</th>
					<td><input class="text required auto-init"
						data-auto-init="<%=file == null ? "focus-select" : "focus" %>"
						type="text" name="url" id="url"
						value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("url")) : file.getUrl())%>" 
						size="40" maxlength="<%=File.MAX_URL_LENGTH%>"><br>
						<span title="Issues a HEAD request to the given URL in order to find size, MIME type, etc.">
						<input type="checkbox" name="loadMetadata" id="loadMetadata" value="1" <%=file == null ? "checked" : "" %> 
							><label for="loadMetadata">Load metadata</label></span>
					</td>
					<td></td>
				</tr>
				<tr>
				<th>Server</th>
				<td>
					<base:select 
						id="server_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentFileServer%>"
						denied="<%=!readCurrentFileServer%>"
						recent="<%=recentFileServers%>"
						newitem="<%=file == null%>"
					/>
				</td>
				<td></td>
			</tr>
				<%
			}
			%>
			<tr>
				<th>Name</th>
				<td><input class="text required <%=!isURL ? "auto-init" : ""%>
					data-auto-init="<%=file == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("name")) : file.getName())%>" 
					size="40" maxlength="<%=File.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th><label for="writeProtected">Write protected</label></th>
				<td><input type="checkbox" name="write_protected" id="writeProtected" value="1" 
					<%=(file != null && file.isWriteProtected()) || 
						(file == null && Values.getBoolean(cc.getPropertyValue("writeProtected"))) ? "checked" : ""%>></td>
				<td></td>
			</tr>
			<tr >
				<th>Type</th>
				<td>
					<select name="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && file != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>MIME type</th>
				<td><table style="width: 100%;">
					<tr>
						<td style="width: 98%;"><input class="text" type="text" name="mime_type" 
							value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("mimeType")) : file.getMimeType())%>" 
							maxlength="<%=File.MAX_MIMETYPE_LENGTH%>"></td>
						<td><base:button id="selectMimeType" title="Select&hellip;"/></td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Character set</th>
				<td>
					<select name="characterSet" class="selectionlist">
					<option value="">- n/a -
					<%
					String currentCharset = file == null ? 
						Values.getStringOrNull(cc.getPropertyValue("characterSet")) : file.getCharacterSet();
					int numCommon = Config.getCommonCharsets().size();
					int i = 0;
					boolean hasMatched = false;
					for (String charset : Config.getAllCharsets())
					{
						boolean selected = false;
						if (!hasMatched)
						{
							selected = charset.equalsIgnoreCase(currentCharset);
							hasMatched |= selected;
						}
						%>
						<option value="<%=charset%>" <%=selected ? "selected" : ""%> 
							<%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
						<%
						i++;
					}
					if (!hasMatched && currentCharset != null)
					{
						%>
						<option value="<%=currentCharset%>" selected><%=currentCharset%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" name="description" id="description"
						><%=HTML.encodeTags(file == null ? cc.getPropertyValue("description") : file.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
